select
   co.codigo as codigo_coleta
  ,co.datacoleta as data_coleta
  ,an.numero as doadora
  ,an.nome as nome_doadora
  ,rep.numero as reprodutor
  ,rep.nome as nome_reprodutor
  ,te.data as data_te
  ,emb.numero as embriao
  ,rec.numero as receptora
  ,(case when (diag.cdreproducao is null) then 'Aberto'
         when (diag.diagnostico = 'P') then 'Positivo'
         else 'Negativo' end) as diagnostico_te
  ,(case when (diag.diagnostico = 'P') then diag.dtpartoprovavel else null end) as parto_provavel
from
  animal an 
  join animal emb on emb.cdmae = an.cdanimal
  join reproducao te on te.cdembriao = emb.cdanimal
  left join animal rep on rep.cdanimal = emb.cdpai
  join animal rec on rec.cdanimal = te.cdanimal
  left join reproducao diag on diag.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = te.cdanimal and re.data > te.data
    and ((re.cdtiporeproducao in (1,2,3)) or (re.cio in (1,2)) or (re.diagnostico is not null)) order by re.data asc)
  left join coleta co on co.cdcoleta = te.cdcoleta
where
  rec.dtbaixa is null
order by
  co.datacoleta